% Program 2_1
% Generation of the ensemble average
%
R = 50;
n = 0:R-1;
s = 2*n.*(0.9.^n); % Generate the uncorrupted signal
d = rand(R,1)-0.5; % Generate the random noise
x1 = s+d';
figure;
subplot(2,2,1)
stem(n,s);
xlabel('Time index n');ylabel('Amplitude'); title('Signal');
grid on;
subplot(2,2,2)
stem(n,d);
xlabel('Time index n');ylabel('Amplitude'); title('Noise');
grid on;
subplot(2,2,3)
stem(n,x1);
xlabel('Time index n');ylabel('Amplitude'); title('Corrupted Signal');
grid on;
for k = 1:50;
    d = rand(R,1)-0.5;
    x = s + d';
    x1 = x1 + x;
end
x1 = x1/50;
subplot(2,2,4);
stem(n,x1);
xlabel('Time index n');ylabel('Amplitude'); title('Ensemble average');
grid on;